## Applitools Eyes SDK for  JavaScript.

## Getting started

To get started with this SDK, you need to set the following:

* [Applitools API key](#API)
* [Eyes server URL](#URL) - Required only if the Eyes server is not deployed on the Eyes public server.

### Entering the Applitools API key {#API}

To authenticate via the Applitools server and run tests, you need to set the environment variable `APPLITOOLS_API_KEY` to the API key provided from Applitools Eyes. For details how to retrieve your API key, see [the Applitools documentation](/getting-started/retrieve-api-key).

#### Entering the API Key on Linux or a Mac


```bash
export APPLITOOLS_API_KEY=<API_key>
```

#### Entering the API Key on Windows

```bash
set APPLITOOLS_API_KEY=<API_key>
```

### Eyes server URL {#URL}

If the Eyes server is not deployed in `https://eyes.applitools.com`, you need to set the Server URL in the environment variable `APPLITOOLS_SERVER_URL`  before running tests.

The server URL of your Applitools Eyes dashboard is in the format `https://<MY_COMPANY>.applitools.com`


#### Entering the server URL on Linux or a Mac

```bash
export APPLITOOLS_SERVER_URL=<YOUR_SERVER_URL>
```

#### Entering the server URL on Windows

```bash
set APPLITOOLS_SERVER_URL=<YOUR_SERVER_URL>
```

## Further information

For further information, see:

* [Quickstart](https://applitools.com/tutorials/sdks/selenium-js/quickstart)
* [Overview](https://applitools.com/tutorials/sdks/selenium-js)
* [Changelog](https://applitools.com/tutorials/sdks/selenium-js/changelog)		
